package main

import "fmt"

func main (){
	list := []int{5, 13, 55, 6, 1, 9, 4, 13, 555, 0}
	fmt.Println(mergesort(list))
}

func mergesort(x []int) []int{
	if len(x) <= 1 {
		return x
	}
	first:= mergesort(x[:len(x)/2]) // bis (ohne len(x)/2)
	second:= mergesort(x[len(x)/2:]) // ab (mit len(x)/2)
	return merge(first, second)
}

func merge(f []int, s []int) []int {
	result := make([]int, len(s)+len(f))
	i, j, x := 0, 0, 0
	for i < len(f) && j < len(s) {
		if f[i] < s[j] {
			result[x] = f[i]
			x++
			i++
		} else {
			result[x] = s[j]
			x++
			j++
		}
	}
	for i < len(f) {
		result[x] = f[i]
		x++
		i++
	}
	for j < len(s) {
		result[x] = s[j]
		x++
		j++
	}
	return result
}
