package qu

import (
  . "gokurs/obj"
  "gokurs/seq"
)
type
  sequence struct {
                  seq.Sequence
                  }

func New (a Any) *sequence {
  return &sequence { seq.New (a) }
}

func (x *sequence) Ins (a Any) {
  x.Seek (x.Num())
  x.Sequence.Ins (a)
}

func (x *sequence) Get() Any {
  if x.Empty() { return nil }
  x.Seek (0)
  return x.Sequence.Get()
}

func (x *sequence) Del() Any {
  if x.Empty() { return nil }
  x.Seek (0)
  defer x.Sequence.Del()
  return x.Get()
}

func (x *sequence) Empty() bool {
  return x.Sequence.Empty()
}

func (x *sequence) Num() uint {
  return x.Sequence.Num()
}
