package r3num

import (
  . "fmt"
  . "gokurs/obj"
  . "gokurs/num"
)
type
  Root3Number interface { // Zahlen der Form a + sqrt(3) * b für ganzzahlige a, b
                          // Mit "x" ist immer das aufrufende Objekt gemeint.

  Object // s. package gokurs/obj
  Stringer
  Number

// Liefert den reellen Wert von x.
  Val() float64

// Liefert (a, b), wenn x den Wert a + sqrt(3) * b hat.
  Get() (int, int)

// x ist die Zahl mit dem Wert a + sqrt(3) * b.
  Set (a, b int)
}
