package main

func changeRec(amount int, coins[]int) []int {
  if len(coins) == 0 {
    return make([]int, 0)
  }
  tmp:= changeRec(amount % coins[0], coins[1:])
  return append ([]int{ amount / coins[0] }, tmp...)
}

func changeIt(amount int, coins []int) []int {
  var result = make ([]int, len (coins))
  for index, element:= range (coins) {
    result[index] = amount / element
    amount %= element
  }
  return result
}

func main () {
  var amount int = 456
  var coins []int = []int{ 200, 100, 50, 20, 10, 5, 2, 1 }
  result:= changeRec (amount, coins)
//  result:= changeIt (amount, coins)
  for i, element:= range (result) {
    println (element, "*", coins[i])
  }
}
