package queue

import
  . "gokurs/obj"
type
  Queue interface { // Warteschlangen nach Fifo

// Mit x ist jeweils das aufrufende Objekt gemeint.

// Der Konstruktor liefert eine neue leere Warteschlange.  
// New() Queue

// An x ist a als Element an letzter Stelle hinzugefügt;
// alle anderen Elemente aus x sind in unveränderter Reihenfolge erhalten;
// nichts anderes ist hinzugefügt.
  Enqueue (a Any)

// Pre: x ist nicht leer.
// Liefert das erste Element von x.
  Head() int

// Pre: x ist nicht leer.
// Das erste Element aus x ist entfernt;
// alle anderen Elemente aus x sind in unveränderter Reihenfolge erhalten.
  Dequeue()

// Liefert genau dann true, wenn x leer ist.
  Empty() bool
}
